#----------------------------------------------------------------------------
!ifndef VcDir
!error VcDir path name (Visual C++ base directory) not defined!
!endif
#----------------------------------------------------------------------------

VcBinDir = $(VcDir)\bin
VcIncDir = $(VcDir)\include
VcLibDir = $(VcDir)\lib

VcIncOpts = -I$(VcIncDir)

!ifdef DEBUG
cRuntime = $(VcLibDir)\libcd.lib $(VcLibDir)\libc.lib
!else
cRuntime = $(VcLibDir)\libc.lib
!endif

crt_opt = -ML

commonCOpts = -c -W3 -DWIN32 -DwinNT $(crt_opt) -D_VISCXX -nologo
!ifdef DEBUG
commonCOpts = $(commonCOpts) -D_DEBUG
!endif
!ifdef isDLL
commonCOpts = $(commonCOpts) -D_DLL
!endif

x86COpts = -D_X86_=1 -Di386=1 -G5

!ifndef DEBUG
x86COpts = $(x86COpts) -Ob1
!endif

VcCompOpts =  $(x86COpts) $(commonCOpts)

VcLibs     = $(VcLibDir)\gdi32.lib \
            $(VcLibDir)\user32.lib \
            $(VcLibDir)\oldnames.lib \
            $(VcLibDir)\kernel32.lib \
            $(VcLibDir)\uuid.lib \
            $(cRuntime)

consoleOpts = -subsystem:console -entry:mainCRTStartup

usedVcLibs = $(VcLibs)
VcLinkOpts = $(consoleOpts)

debugType = cv

!ifdef DEBUG
VcCompOpts = $(VcCompOpts) -Zi -Od
VcLinkOpts = -debug:full -debugtype:$(debugType)
VcDllOpts  = -debug:full -debugtype:$(debugType)
!endif

VcCompCmd  = $(VcBinDir)\cl
VcLinkCmd  = $(VcBinDir)\link -out:$@ $(VcLinkOpts) $(usedVcLibs)
VcLibCmd   = $(VcBinDir)\lib

#----------------------------------------------------------------------------
#     obj <-- cpp
#----------------------------------------------------------------------------
objFromCppCmd = $(VcCompCmd) $(VcIncOpts) $(MgIncOpts) $(VcCompOpts) \
                -Fo$(target) $(source)

