/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
#include <string.h>
#include <stdio.h>
#include <malloc.h>

#include <mgrtree/BasDef.h>
#include <mgrtree/System.h>
#include <mgrtree/Rtree.h>

#include "T_xx.h"

#undef EndOfIncludesSection
/*------------------------------------------------------------------------- o
       private definitions
o -------------------------------------------------------------------------*/
class TestRange : public XyRange {
 public:
  void init (int ix, int iy) {
    fromLlUr (XyPoint ((ix + 0) * 1.0, (iy + 0) * 1.0),
              XyPoint ((ix + 1) * 1.0, (iy + 1) * 1.0));
  }
  TestRange (int ix, int iy) { init (ix, iy); }
  TestRange () {}
};

class TestRh : public Rh {
 public:
  virtual XyRange range () { int   i = recId.idx;
                             return TestRange (i / 10, i % 10); }
};

class TestXyRtree : public XyRtree {
 public:
  TestXyRtree () { setUfRep (); rhPrototype = new TestRh;}
 public:
  void testInsert ();
  void testSearch ();
};

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
void
TestXyRtree::testInsert ()
{
  int                    i, n;
  n = 50000;
  for (i = 0; i < n; i++) {
    insertRecord (i);
  }
}

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
void
TestXyRtree::testSearch ()
{
  Searcher searcher (*this);
  printSearch (searcher, XyPoint (5.0, 5.0), XyPoint (6.0, 6.0));
  printSearch (searcher, XyPoint (5, 5), XyPoint (5, 5));
}

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
static void
test0 ()
{
  MgSystem::startTime ();

  TestXyRtree rtree;

  rtree.testInsert ();
//  rtree.printLevels();
  rtree.printLevel(0);
  rtree.testSearch();

  MgSystem::printDifTime ();
}

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
void
testDllImport ()
{
  test0 ();
}

