// R-tree Library. A simple 2d- C++ implementation of the R-tree structure
//
// Copyright (C) 2002-2003  Ondrej Pavlata.
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
// Contact information:
//  Mailing address:
//    Ondrej Pavlata
//    V. Nezvala 7a
//    466 02 Jablonec nad Nisou
//    Czech republic
//
//  Email:
//    o.j.p@worldonline.cz

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
#include <string.h>
#include <stdio.h>
#include <malloc.h>

#include <mgrtree/BasDef.h>
#include "XyRangeT.h"

#include <mgrtree/Assert.h>

#undef EndOfIncludesSection
/*------------------------------------------------------------------------- o
       private definitions
o -------------------------------------------------------------------------*/

/*------------------------------------------------------------------------- o
       static global variables
o -------------------------------------------------------------------------*/

/*------------------------------------------------------------------------- o
o -------------------------------------------------------------------------*/
template <class T>
CsizeString<MG_RtreeStrSize_XyRange>
XyRangeT<T>::cstr ()
{
  CsizeString<MG_RtreeStrSize_XyRange>  s;
  if ( isEmpty() )
    s = "<empty range>";
  else if ( isUnlimited() )
    s = "<not limited range>";
  else {
    char   s0[128];
    sprintf (s0, "(%.1f,%.1f),(%.1f,%.1f)",
            (double)ll.x, (double)ll.y, (double)ur.x, (double)ur.y);
    s = s0;
  }
  return  s;
}

CsizeString<MG_RtreeStrSize_XyRange>
XyRangeI::cstr ()
{
  if ( isEmpty() || isUnlimited() )
    return XyRangeT<int>::cstr();
  CsizeString<MG_RtreeStrSize_XyRange>  s;
  char   s0[128];
  sprintf (s0, "(%d,%d),(%d,%d)", ll.x, ll.y, ur.x, ur.y);
  s = s0;
  return  s;
}

CsizeString<MG_RtreeStrSize_XyRange>
XyRangeD::cstr ()
{
  return XyRangeT<double>::cstr();
}

/*------------------------------------------------------------------------- o
   easy VC debug access
o -------------------------------------------------------------------------*/
const char *
XyRangeI::str ()
{
  static CsizeString<MG_RtreeStrSize_XyRange> s;
  s = cstr();
  return s.s();
}
const char *
XyRangeD::str ()
{
  static CsizeString<MG_RtreeStrSize_XyRange> s;
  s = cstr();
  return s.s();
}



