#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
!ifndef MgRtLib
MgRtLib=$(MAKEDIR)
#!error MgRtLib directory path name not defined!
!endif

!include $(MgRtLib)/mak/mgrtree.mak

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
xxDir = $(MgRtLib)\src\MgRtree

#----------------------------------------------------------------------------
#
#----------------------------------------------------------------------------

all: $(allDllObjs) $(allExeObjs)

#----------------------------------------------------------------------------
#  Compile static libraries
#----------------------------------------------------------------------------
source = $(miscSrcDir)\System.cpp
target = $(xxOutDir)\System.obj
$(target) : $(source)
  $(objFromCppCmd)

#----------------------------------------------------------------------------
#  Build the DLL
#----------------------------------------------------------------------------
isDLL = 1

libDllObjs = \
           $(xxOutDir)\System.obj \

xxDllObjs = \
           $(xxOutDir)\Rtree.obj \
           $(xxOutDir)\XyRangeT.obj \
           $(xxOutDir)\UfRep.obj \
           $(xxOutDir)\UfRepIns.obj \
           $(xxOutDir)\UfRepDel.obj \

allDllObjs = $(initDllObjs) $(libDllObjs) $(xxDllObjs)

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
source = $(xxDir)\Rtree.cpp
target = $(xxOutDir)\Rtree.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\XyRangeT.cpp
target = $(xxOutDir)\XyRangeT.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\UfRep.cpp
target = $(xxOutDir)\UfRep.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\UfRepIns.cpp
target = $(xxOutDir)\UfRepIns.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\UfRepDel.cpp
target = $(xxOutDir)\UfRepDel.obj
$(target) : $(source)
  $(objFromCppCmd)

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
dllName = MgRtree
!include $(MgRtLib)/mak/dll.mak

#----------------------------------------------------------------------------
#  Build xx.exe for immediate tests
#----------------------------------------------------------------------------
!undef isDLL

xxExeObjs = \
             $(xxOutDir)\xx.obj \
             $(xxOutDir)\T_xx.obj \

libExeObjs = \
           $(xxOutDir)\System.obj \
           $(xxOutDir)\$(dllName).lib \

allExeObjs = $(libExeObjs) $(xxExeObjs)

#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
source = $(xxDir)\xx.cpp
target = $(xxOutDir)\xx.obj
$(target) : $(source)
  $(objFromCppCmd)

source = $(xxDir)\T_xx.cpp
target = $(xxOutDir)\T_xx.obj
$(target) : $(source)
  $(objFromCppCmd)


#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
exeFileName = $(xxOutDir)\xx.exe

$(exeFileName)         : $(allExeObjs)
  $(VcLinkCmd) @<<$(xxOutDir)\link_exe.cmd
  -nologo
  $(allExeObjs)
<<keep


#----------------------------------------------------------------------------
#----------------------------------------------------------------------------
all: $(dllFileName) $(libFileName) $(exeFileName)

#!message end reached
